VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmMakeMap 
   Caption         =   "MakeMap []"
   ClientHeight    =   2775
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   4935
   LinkTopic       =   "Form2"
   ScaleHeight     =   2775
   ScaleWidth      =   4935
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer tmrFinished 
      Enabled         =   0   'False
      Interval        =   150
      Left            =   3240
      Top             =   1920
   End
   Begin VB.PictureBox picHidden 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   1695
      Left            =   2400
      ScaleHeight     =   109
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   117
      TabIndex        =   1
      Top             =   120
      Visible         =   0   'False
      Width           =   1815
   End
   Begin MSComDlg.CommonDialog dlgOpenFile 
      Left            =   1560
      Top             =   480
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.PictureBox picVisible 
      AutoSize        =   -1  'True
      Height          =   2295
      Left            =   0
      ScaleHeight     =   149
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   189
      TabIndex        =   0
      Top             =   0
      Width           =   2895
   End
   Begin VB.Label lblState 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   0
      TabIndex        =   2
      Top             =   2520
      Width           =   4935
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open..."
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileExitSep 
         Caption         =   "-"
         Index           =   8
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuOpt 
      Caption         =   "&Options"
      Begin VB.Menu mnuOptNewGame 
         Caption         =   "&New Game"
         Enabled         =   0   'False
         Shortcut        =   {F2}
      End
   End
End
Attribute VB_Name = "frmMakeMap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_States As Collection
Private m_SelectedState As State
Private m_StateNum As Integer

Private m_StartTime As Single
Private m_Playing As Boolean
Private m_Mistakes As Integer

Private m_Blinks As Integer
' Arrange the controls.
Private Sub ArrangeControls()
    lblState.Move 0, picVisible.Height, _
        picVisible.Width

    ' Make the form big enough.
    Width = picVisible.Width + Width - ScaleWidth
    Height = lblState.Top + lblState.Height + Height - ScaleHeight

    DoEvents
End Sub
Private Sub LoadData(ByVal file_name As String)
Dim fnum As Integer
Dim num_states As Integer
Dim i As Integer
Dim s As State

    file_name = Left$(file_name, InStrRev(file_name, ".")) & "dat"

    Set m_States = New Collection

    fnum = FreeFile
    On Error Resume Next
    Open file_name For Input As fnum
    If Err.Number <> 0 Then Exit Sub

    Input #fnum, num_states
    For i = 1 To num_states
        Set s = New State
        s.ReadFromFile fnum
        m_States.Add s, s.StateName
    Next i

    Close #fnum
End Sub
Private Sub ShowNextState()
Dim msg As String

    m_StateNum = m_StateNum + 1
    If m_StateNum > m_States.Count Then
        msg = "Finished in " & _
            Format$(CInt(Timer - m_StartTime)) & _
            " seconds with "
        If m_Mistakes = 0 Then
            msg = msg & "no mistakes!"
        ElseIf m_Mistakes = 1 Then
            msg = msg & "only 1 mistake."
        Else
            msg = msg & Format$(m_Mistakes) & " mistakes."
        End If
        lblState.Caption = msg

        m_Playing = False
        m_Blinks = 0
        tmrFinished.Enabled = True
        Exit Sub
    End If

    Set m_SelectedState = m_States(m_StateNum)
    lblState.Caption = m_SelectedState.StateName
End Sub
' Start in the current directory.
Private Sub Form_Load()
    Randomize

    picVisible.FillStyle = vbFSSolid
    picHidden.FillStyle = vbFSSolid

    Set m_States = New Collection

    picVisible.AutoSize = True
    picVisible.ScaleMode = vbPixels
    picVisible.AutoRedraw = True

    dlgOpenFile.CancelError = True
    dlgOpenFile.InitDir = App.Path
    dlgOpenFile.Filter = _
        "Bitmaps (*.bmp)|*.bmp|" & _
        "GIFs (*.gif)|*.gif|" & _
        "JPEGs (*.jpg)|*.jpg;*.jpeg|" & _
        "Icons (*.ico)|*.ico|" & _
        "Cursors (*.cur)|*.cur|" & _
        "Run-Length Encoded (*.rle)|*.rle|" & _
        "Metafiles (*.wmf)|*.wmf|" & _
        "Enhanced Metafiles (*.emf)|*.emf|" & _
        "Graphic Files|*.bmp;*.gif;*.jpg;*.jpeg;*.ico;*.cur;*.rle;*.wmf;*.emf|" & _
        "All Files (*.*)|*.*"

    ArrangeControls
End Sub

Private Sub mnuFileExit_Click()
    Unload Me
End Sub

' Load the indicated file.
Private Sub mnuFileOpen_Click()
Dim file_name As String
Dim file_title As String

    ' Let the user select a file.
    On Error Resume Next
    dlgOpenFile.Flags = cdlOFNFileMustExist + cdlOFNHideReadOnly
    dlgOpenFile.ShowOpen
    If Err.Number = cdlCancel Then
        Exit Sub
    ElseIf Err.Number <> 0 Then
        Beep
        MsgBox "Error selecting file.", , vbExclamation
        Exit Sub
    End If
    On Error GoTo 0

    Screen.MousePointer = vbHourglass
    DoEvents

    file_name = Trim$(dlgOpenFile.FileName)
    dlgOpenFile.InitDir = Left$(file_name, Len(file_name) _
        - Len(dlgOpenFile.FileTitle) - 1)
    file_title = Left$(dlgOpenFile.FileTitle, _
        InStrRev(dlgOpenFile.FileTitle, ".") - 1)
    Caption = "MapGame [" & file_title & "]"

    ' Open the original file.
    On Error GoTo LoadError
    picVisible.Picture = LoadPicture(file_name)
    picHidden.Picture = picVisible.Picture
    picHidden.Picture = picHidden.Image
    On Error GoTo 0

    ' Try to load the data.
    LoadData file_name
    mnuOptNewGame.Enabled = True
    ArrangeControls

    Screen.MousePointer = vbDefault
    Exit Sub

LoadError:
    Screen.MousePointer = vbDefault
    MsgBox "Error " & Format$(Err.Number) & _
        " opening file '" & file_name & "'" & vbCrLf & _
        Err.Description
End Sub
Private Sub mnuOptNewGame_Click()
Dim random_states As Collection
Dim i As Integer
Dim idx As Integer

    picVisible.Picture = picHidden.Picture

    lblState.ForeColor = ForeColor
    lblState.BackColor = BackColor

    Set random_states = New Collection
    For i = 1 To m_States.Count
        idx = CInt(Rnd * (m_States.Count - 1) + 1)
        random_states.Add m_States(idx)
        m_States.Remove idx
    Next i

    Set m_States = random_states

    m_Mistakes = 0
    m_StateNum = 0
    m_Playing = True
    m_StartTime = Timer

    ShowNextState
End Sub
Private Sub picVisible_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If Not m_Playing Then Exit Sub

    If m_SelectedState.PointIsSelected(picHidden, X, Y) Then
        ShowNextState
    Else
        Beep
        m_Mistakes = m_Mistakes + 1
    End If
End Sub

Private Sub tmrFinished_Timer()
Dim tmp_color As Long

    tmp_color = lblState.BackColor
    lblState.BackColor = lblState.ForeColor
    lblState.ForeColor = tmp_color
    Beep

    m_Blinks = m_Blinks + 1
    If m_Blinks >= 5 Then
        tmrFinished.Enabled = False
        Exit Sub
    End If
End Sub


